/*
 * Test.java
 * by Phuong, The NGUYEN
 *
 * a program to test cardS4
 * as part of a summer scholarship in RSISE - ANU
 * supervised by: Rajeev, Prabhakar GORE
 *
 * begin: 25 Jan 01
 * last updated: 21 Feb 01
 *
 **********************************************************************
 *
 * SOME WORDS
 *
 * the methods names are very suggestive themselves, so I should not
 * waste my time explaining ... except for some below
 *
 * testPC is to test the 3-level directory (in my case: tests directory
 * which contains 8000 tests)
 * testCard is meant to do the same thing, but with the program running
 * on the card. This proves to be not practical, so I have never used it
 *
 * testPC01: is to test one set of tests (1 level directory, e.g can
 * be any at the bottom the tests, or some other separated sets I have)
 * This is to identify which tests the program fails. So going from 
 * testPc to testPC01, it is like a "divide and conquer",
 * as people often said.
 *
 * testParser and testProver are meant to furthur break down the test
 * to see where the problems lie. First one should check Parser, then
 * check Prover (though the first part can be often ignore, since
 * problems often occur in prover as I make the changes there).
 * when testing Parser and Prover, it is easier if one use the set of
 * only one test (the failed test). testParser and testProver will
 * print the proving procedure in full (Oh, these should be used with
 * earlier version of prover.java, since the latest version is to
 * downloaded into the card, and should not contain though testing)
 *
 * testCard01 is to be used in the same way as testPC01, though it is
 * more concerned with time and problem solving capacity of the card
 * than the correctness of the program (The program should be tested
 * using testPC and testPC01 before it can be loaded into the card).
 *
 **********************************************************************
 */
 

package client;
import card.*;
import java.io.*;
import com.gemplus.gcr.*;
import com.gemplus.gcr.toolkit.*;
import com.gemplus.gcr.toolkit.gemxpresso.*;


public class Test
{
	
	private static CardReader reader = null;
	private static GxCard card;
	private static byte PACKETLEN = 32;
	
	/* this method is learned from the smartcard tutorial ! */
	private static proverInterface getProver() 
		throws javacard.framework.UserException
	{
		/* connect to the reader */
		try
		{
//			for ( SERIALPORT i = SERIALPORT.first(); i != null; i = i.next() ) 
//			{
//				reader = new Gcr410(i);

				reader = new Gcr410(SERIALPORT.G_COM2);
				if(reader == null)
				{
//					System.out.println("port: " + i);
					System.out.println("reader is null");
//					continue;
				}
//			}
/*			
			if(reader == null)
			{
				System.out.println("Can not find any card reader. Exit");
				System.exit(3);
			}
*/
			reader.connect();
			System.out.println("reader's timeout = " + reader.getCommandTimeout());
			System.out.println("set reader's timeout to 60000");
			reader.setCommandTimeout(60000);
		}
		catch(ConnectionException e)
		{
			System.out.println("Could not connect to reader. Bye");
			System.exit(1);
		}
		
		catch(Exception e)
		{
			System.out.println("Some other exceptions occur to card reader");
			System.exit(2);
		}
		
		System.out.println("Reader OK");
		
		/* connect to the card */
		if(reader != null)
		{
			try
			{
				card = new GxCard(reader);
				AnswerToReset atr = card.connect();
				System.out.println("ATR: " + atr.toString());
			}
			catch(ConnectionException e)
			{
				System.out.println("Could not connect to card. Bye");
				System.exit(2);
			}
		}
		
		/* create the proxy to the applet */
		if(card != null)
		{
			GxCabprover gxcard = new GxCabprover(card);
			gxcard.select();
			return gxcard;
		}
		else
		{
			/* return a local version of the card */
			return null;
		}
	}
	
	private static void stopCard()
	{
		System.out.print("Try to stop the card ... ");
		if(reader.dispose()) System.out.println("Success");
		else System.out.println("\n..... Could not stop the card reader");
	}

	public static void main(String [] args)
	{
		if(args.length == 0)
		{
			System.out.println("(t) java Test: should give it an option and a filename");
			System.exit(2);
		}
		if(args[0].equals("pa"))
		{
			if(args.length == 2)
			{
				testParser(args[1]);
			}

			else testParser("h:\\s4");
		}

		else if(args[0].equals("pr"))
		{
			if(args.length == 2)
			{
				testProver(args[1]);
			}

			else testProver("h:\\s4");
		}

		else if(args[0].equals("ca"))
		{
			if(args.length == 2)
			{
				testCard(args[1]);
			}

			else testCard("h:\\s4\\tests");
		}

		else if(args[0].equals("pc"))
		{
			if(args.length == 2)
			{
				testPC(args[1]);
			}
			else testPC("h:\\s4\\tests");
		}

		else if(args[0].equals("ca01"))
		{
			if(args.length == 2)
			{
				testCard01(args[1]);
			}

			else testCard01("h:\\s4");
		}

		else if(args[0].equals("pc01"))
		{
			if(args.length == 2)
			{
				testPC01(args[1]);
			}

			else testPC01("h:\\s4");
		}
		
		else if(args[0].equals("cv"))
		{
			if(args.length == 2)
			{
				testConverter(args[1]);
			}

			else testConverter("h:\\s4");
		}
		
		

		else
		{
			System.out.println("Invalide option: [pc | pc01 | ca | ca01 | pa | pr] dir_name");
			System.exit(3);
		}
	}

	/* This test assumes that this class is in the same directory as the
	 * directory which contains the directory *dir*
	 * ORDER:
	 *	dir1
	 *		dir2
	 *			dir3
	 *				s4_formulae, s4_results
	 */
	public static void testCard(String dirname)
	{
		File dir1, dir2, dir3;//, list_dir1[], list_dir2[];
		String list_dir1[], list_dir2[];
		String delimiter = "\\"; /* for window */

		LineNumberReader file_forms, file_results;
		String line_form, line_result;
		parser parser = new parser();
		converter converter = new converter();
		proverInterface prover = null;
		long start, end;
		
		try
		{
			prover = getProver();
		}
		catch(javacard.framework.UserException e)
		{
			System.out.println("testCard: Could not get the prover");
			System.exit(1);
		}
		byte output = 0;
		int count, tot_count = 0, fails, tot_fails = 0;
		String test_fails = "";
		
		String filename_forms = "";
		String filename_results = "";
		
		if(dirname == null)
		{
			System.out.println("dirname not given. Bye.");
			System.exit(1);
		}

		System.out.println("********************************************************");
		System.out.println("Entering directory \"" + dirname + "\"");
		dir1 = new File(dirname);
//		list_dir1 = dir1.listFiles();
		list_dir1 = dir1.list();

		for(int i = 0; i<list_dir1.length; i++)
		{
			/* why the list also contains "FINDER.DAT" (in Window) ? */
/*
			if(!list_dir1[i].isDirectory()) continue;			
			dir2 = list_dir1[i];
*/
			
			dir2 = new File(dir1, list_dir1[i]);
			if(!dir2.isDirectory()) continue;

			System.out.println("\nEntering sub-directory \"" + dir2.getName() + "\"");
//			list_dir2 = dir2.listFiles();
			list_dir2 = dir2.list();
			for(int j = 0; j<list_dir2.length; j++)
			{
/*
				if(!list_dir2[j].isDirectory()) continue;				
				dir3 = list_dir2[j];
*/
				dir3 = new File(dir2, list_dir2[j]);
				if(!dir3.isDirectory()) continue;

				System.out.println("\"" + dir3.getAbsolutePath() + "\"");

				filename_forms = dir3.getAbsolutePath() + delimiter + "s4_formulae";
				filename_results = dir3.getAbsolutePath() + delimiter + "s4_results";

				fails = 0; count = 0; test_fails = "";
				try
				{
					file_forms = new LineNumberReader(new FileReader(filename_forms));
					file_results = new LineNumberReader(new FileReader(filename_results));
			
					line_form = file_forms.readLine();
					line_result = file_results.readLine();
					while(line_form != null)
					{
						if(line_form.equals(""))
						{
							System.out.println("\n>>>See an empty line in formulae files. Output may not match from here");
							line_form = file_forms.readLine();
							line_result = file_results.readLine();
							continue	;
						}

						count ++;

						/* give the string to the scanner */
						scanner.getInput(line_form);
		
		
						try
						{
							parser.parse();
						} catch (Exception e)
						{
							System.out.println("--------Error in parser-------");
						}
		
						converter.convert(parser);

try
{
				System.out.println("\nStart sending 'childs' to the card");
				int num_packs = (int)(converter.childs.length/PACKETLEN);
				System.out.println("length = " + converter.childs.length + "num packs = " + (num_packs + 1));
				short offset = 0;
				byte pack[];
				int pack_count = 0;
				for(int ii=0; ii<num_packs; ii++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int jj=0; jj<PACKETLEN; jj++)
						pack[jj] = converter.childs[jj+offset];
					start = System.currentTimeMillis();
					prover.getChilds(pack, offset, PACKETLEN);
					offset += PACKETLEN;
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						PACKETLEN + ")" + "\t\ttime = " + (end - start));
				}
				
				/* last package */
				if(offset < converter.childs.length)
				{
					pack_count ++;
					byte len = (byte)(converter.childs.length - offset);
					pack = new byte[len];
					for(int jj=0; jj<len; jj++)
						pack[jj] = converter.childs[jj+offset];
					start = System.currentTimeMillis();
					prover.getChilds(pack, offset, len);
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						len + ")" + "\t\ttime = " + (end - start));
				}
				

				System.out.println("\nStart sending 'nature' to the card");
				pack_count = 0;
				offset = 0;
				num_packs = (int)(converter.nature.length/PACKETLEN);
				System.out.println("length = " + converter.nature.length + "num packs = " + (num_packs + 1));
								
				for(int ii=0; ii<num_packs; ii++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int jj=0; jj<PACKETLEN; jj++)
						pack[jj] = converter.nature[jj+offset];
					start = System.currentTimeMillis();
					prover.getNature(pack, (byte)offset, PACKETLEN);
					offset += PACKETLEN;
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						PACKETLEN + ")" + "\t\ttime = " + (end - start));
				}
				
				/* last package */
				if(offset < converter.nature.length)
				{
					pack_count ++;
					byte len = (byte)(converter.nature.length - offset);
					pack = new byte[len];
					for(int jj=0; jj<len; jj++)
						pack[jj] = converter.nature[jj+offset];
					start = System.currentTimeMillis();
					prover.getNature(pack, (byte)offset, len);
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						len + ")" + "\t\ttime = " + (end - start));
				}


				System.out.println("\nStart request for optimization");
				start = System.currentTimeMillis();
				output = prover.simplify();
				end = System.currentTimeMillis();
				long opt_time = end-start;
				System.out.println("Result = " + output + "\t\ttime = " + opt_time);

				System.out.println("\nStart request for proof from the card");
				start = System.currentTimeMillis();

				output = prover.prove();
				end = System.currentTimeMillis();
				long pro_time = end - start;


				if(output == 1) System.out.println("\noutput: SATISFIABLE");
				else System.out.println("\noutput: NOT SATISFIABLE");

				System.out.print("result: is satisfiable = " + line_result);
				if(output == 1)
				{
					if(line_result.equals("true")) System.out.println("\t\t\ttest " + count + " PASS");
					else
					{
						System.out.println("\t\t\ttest " + count + " FAIL");
						fails ++;
						test_fails += ("" + count + " ");
					}
				}
				else
				{
					if(line_result.equals("false")) System.out.println("\t\t\ttest " + count + " PASS");
					else
					{
						System.out.println("\t\t\ttest " + count + " FAIL");
						fails ++;
						test_fails += ("" + count + " ");
					}
				}
				
				System.out.println("Time proving = " + pro_time);
				
				System.out.println("Total optimization + proving = " + (opt_time + pro_time));
				System.out.println("------------------------------------------------------------------");
				
}
catch(CardError ce)
{
	System.out.println(">>>>> CARDERROR <<<<<");
	System.out.println(ce);

}

						
						/* reads next line */
						line_form = file_forms.readLine();
						line_result = file_results.readLine();
					}

					System.out.print(count + " tests");
					System.out.print(" fails = " + fails);
					if(!test_fails.equals(""))
					{
						System.out.println(" ( " + test_fails + " )");
					}
					else System.out.println();

					
					tot_fails += fails; tot_count += count;
					
				}
				catch (IOException ioe)
				{
					System.out.println("IO Error...");
				}		
			}
			
			System.out.println("-------------------------------------------------------------");
		}
		
		System.out.println("\nTotal: " + tot_count + " formulae\t fails: " + tot_fails);
		
		/* stopping the card */
		stopCard();
	}


	/* the test before installing the prover into the card */
	public static void testPC(String dirname)
	{
		File dir1, dir2, dir3;//, list_dir1[], list_dir2[];
		String list_dir1[], list_dir2[];
		String delimiter = "\\"; /* for window */

		LineNumberReader file_forms, file_results;
		String line_form, line_result;
		parser parser = new parser();
		converter converter = new converter();
		proverInterface prover = new prover();
		int output = 0;
		int count, tot_count = 0, fails, tot_fails = 0;
		String test_fails = "";
		
		String filename_forms = "";
		String filename_results = "";
		
		if(dirname == null)
		{
			System.out.println("dirname not given. Bye.");
			System.exit(1);
		}

		System.out.println("********************************************************");
		System.out.println("Entering directory \"" + dirname + "\"");
		dir1 = new File(dirname);
//		list_dir1 = dir1.listFiles();
		list_dir1 = dir1.list();

		for(int i = 0; i<list_dir1.length; i++)
		{
			/* why the list also contains "FINDER.DAT" (in Window) ? */
/*
			if(!list_dir1[i].isDirectory()) continue;
			dir2 = list_dir1[i];
*/
	
			dir2 = new File(dir1, list_dir1[i]);
			if(!dir2.isDirectory()) continue;

			System.out.println("\nEntering sub-directory \"" + dir2.getName() + "\"");
//			list_dir2 = dir2.listFiles();
			list_dir2 = dir2.list();
			for(int j = 0; j<list_dir2.length; j++)
			{
/*
				if(!list_dir2[j].isDirectory()) continue;
				dir3 = list_dir2[j];
*/
				dir3 = new File(dir2, list_dir2[j]);
				if(!dir3.isDirectory()) continue;

				System.out.print("\"" + dir3.getAbsolutePath() + "\" ... ");

				filename_forms = dir3.getAbsolutePath() + delimiter + "s4_formulae";
				filename_results = dir3.getAbsolutePath() + delimiter + "s4_results";

				fails = 0; count = 0; test_fails = "";
				try
				{
					file_forms = new LineNumberReader(new FileReader(filename_forms));
					file_results = new LineNumberReader(new FileReader(filename_results));
			
					line_form = file_forms.readLine();
					line_result = file_results.readLine();
					while(line_form != null)
					{
						if(line_form.equals(""))
						{
							System.out.println("\n>>>See an empty line in formulae files. Output may not match from here");
							line_form = file_forms.readLine();
							line_result = file_results.readLine();
							continue	;
						}

						count ++;

						/* give the string to the scanner */
						scanner.getInput(line_form);
		
		
						try
						{
							parser.parse();
						} catch (Exception e)
						{
							System.out.println("--------Error in parser-------");
						}
		
						converter.convert(parser);


				int num_packs = (int)(converter.childs.length/PACKETLEN);
				short offset = 0;
				byte pack[];
				int pack_count = 0;
				for(int ii=0; ii<num_packs; ii++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int jj=0; jj<PACKETLEN; jj++)
						pack[jj] = converter.childs[jj+offset];

					prover.getChilds(pack, offset, PACKETLEN);
					offset += PACKETLEN;
				}
				
				/* last package */
				if(offset < converter.childs.length)
				{
					pack_count ++;
					byte len = (byte)(converter.childs.length - offset);
					pack = new byte[len];
					for(int jj=0; jj<len; jj++)
						pack[jj] = converter.childs[jj+offset];
					prover.getChilds(pack, offset, len);
				}
				
				pack_count = 0;
				offset = 0;
				num_packs = (int)(converter.nature.length/PACKETLEN);
				
				for(int ii=0; ii<num_packs; ii++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int jj=0; jj<PACKETLEN; jj++)
						pack[jj] = converter.nature[jj+offset];

					prover.getNature(pack, (byte)offset, PACKETLEN);
					offset += PACKETLEN;
				}
				
				/* last package */
				if(offset < converter.nature.length)
				{
					pack_count ++;
					byte len = (byte)(converter.nature.length - offset);
					pack = new byte[len];
					for(int jj=0; jj<len; jj++)
						pack[jj] = converter.nature[jj+offset];
					prover.getNature(pack, (byte)offset, len);
				}


				output = prover.simplify();


						output = prover.prove();
		
						if(output == 1)
						{
							if(line_result.equals("true"))
							{
							}
							else
							{
								fails ++;
								test_fails += ("" + count + " ");
							}
						}
						else
						{
							if(line_result.equals("false")) 
							{
							}
							else
							{
								fails ++;
								test_fails += ("" + count + " ");
							}
						}
						
						/* reads next line */
						line_form = file_forms.readLine();
						line_result = file_results.readLine();
					}

					System.out.print(count + " tests");
					System.out.print(" fails = " + fails);
					if(!test_fails.equals(""))
					{
						System.out.println(" ( " + test_fails + " )");
					}
					else System.out.println();

					
					tot_fails += fails; tot_count += count;
					
				}
				catch (IOException ioe)
				{
					System.out.println("IO Error...");
				}		
			}
			
			System.out.println("-------------------------------------------------------------");
		}
		
		System.out.println("\nTotal: " + tot_count + " formulae\t fails: " + tot_fails);
	}


	/* this test require the class file to be placed in the same directory
	 * which contains the directory *dir*
	 * *dir* is assumed to contain a pair of files: s4_formulae and s4_results
	 */	
	public static void testCard01(String dir)
	{
		LineNumberReader file_forms, file_results;
		String line_form, line_result;
		parser parser = new parser();
		proverInterface prover = null;
		long start=0, end=0;
		long max_time = 0;
		int max_time_form = 0;
		try
		{
			prover = getProver();
		}
		catch(javacard.framework.UserException e)
		{
			System.out.println("test: Could not get prover");
			System.exit(1);
		}
		converter converter = new converter();
		
		int output = 0;
		int count = 1;
		int fails = 0;
		String test_fails = "";
		
		String filename_forms = "s4_formulae";
		String filename_results = "s4_results";
		
		if(dir != null)
		{
			filename_forms = dir + "\\" + filename_forms;
			filename_results = dir + "\\" + filename_results;
		}
		
		System.out.println("Read formulae from \"" + filename_forms + "\"");
		System.out.println("Read results from \"" + filename_results + "\"");
		try
		{
			file_forms = new LineNumberReader(new FileReader(filename_forms));
			file_results = new LineNumberReader(new FileReader(filename_results));
			
			line_form = file_forms.readLine();
			line_result = file_results.readLine();
			while(line_form != null)
			{
				if(line_form.equals(""))
				{
					System.out.println(">>>See an empty line in formulae files. Output may not match from here");
					line_form = file_forms.readLine();
					line_result = file_results.readLine();
					continue	;
				}
				System.out.println("\ninput to prover="+"\""+line_form+"\"");

				/* give the string to the scanner */
				scanner.getInput(line_form);

				try
				{
					parser.parse();
				} catch (Exception e)
				{
					System.out.println("--------Error in parser-------");
					stopCard();
					System.exit(2);
				}

				converter.convert(parser);

try
{
				System.out.println("\nStart sending 'childs' to the card");
				int num_packs = (int)(converter.childs.length/PACKETLEN);
				short offset = 0;
				byte pack[];
				int pack_count = 0;
				for(int i=0; i<num_packs; i++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int j=0; j<PACKETLEN; j++)
						pack[j] = converter.childs[j+offset];
					start = System.currentTimeMillis();
					prover.getChilds(pack, offset, PACKETLEN);
					offset += PACKETLEN;
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						PACKETLEN + ")" + "\t\ttime = " + (end - start));
				}
				
				/* last package */
				if(offset < converter.childs.length)
				{
					pack_count ++;
					byte len = (byte)(converter.childs.length - offset);
					pack = new byte[len];
					for(int j=0; j<len; j++)
						pack[j] = converter.childs[j+offset];
					start = System.currentTimeMillis();
					prover.getChilds(pack, offset, len);
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						len + ")" + "\t\ttime = " + (end - start));
				}
				

				System.out.println("\nStart sending 'nature' to the card");
				pack_count = 0;
				offset = 0;
				num_packs = (int)(converter.nature.length/PACKETLEN);
				
				for(int i=0; i<num_packs; i++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int j=0; j<PACKETLEN; j++)
						pack[j] = converter.nature[j+offset];
					start = System.currentTimeMillis();
					prover.getNature(pack, (byte)offset, PACKETLEN);
					offset += PACKETLEN;
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						PACKETLEN + ")" + "\t\ttime = " + (end - start));
				}
				
				/* last package */
				if(offset < converter.nature.length)
				{
					pack_count ++;
					byte len = (byte)(converter.nature.length - offset);
					pack = new byte[len];
					for(int j=0; j<len; j++)
						pack[j] = converter.nature[j+offset];
					start = System.currentTimeMillis();
					prover.getNature(pack, (byte)offset, len);
					end = System.currentTimeMillis();
					System.out.println("package " + pack_count + " (offset: " + offset + " len: " + 
						len + ")" + "\t\ttime = " + (end - start));
				}


				System.out.println("\nStart request for optimization");
				start = System.currentTimeMillis();
				output = prover.simplify();
				end = System.currentTimeMillis();
				System.out.println("Result = " + output + "\t\ttime = " + (end-start));
				long opt_time = end-start;

				System.out.println("\nStart request for proof from the card");
				start = System.currentTimeMillis();

				output = prover.prove();
				end = System.currentTimeMillis();
				long pro_time = end-start;


				if(output == 1) System.out.println("\noutput: SATISFIABLE");
				else System.out.println("\noutput: NOT SATISFIABLE");

				System.out.print("result: is satisfiable = " + line_result);
				if(output == 1)
				{
					if(line_result.equals("true")) System.out.println("\t\t\ttest " + count + " PASS");
					else
					{
						System.out.println("\t\t\ttest " + count + " FAIL");
						fails ++;
						test_fails += ("" + count + " ");
					}
				}
				else
				{
					if(line_result.equals("false")) System.out.println("\t\t\ttest " + count + " PASS");
					else
					{
						System.out.println("\t\t\ttest " + count + " FAIL");
						fails ++;
						test_fails += ("" + count + " ");
					}
				}
				
				System.out.println("Time proving = " + (end - start));
				System.out.println("Total optimization + proving = " + (opt_time + pro_time));

				if(max_time < end-start)
				{
					max_time = end-start;
					max_time_form = count;
				}

}
catch(CardError ce)
{
	System.out.println(">>>>> CARDERROR <<<<<");
	System.out.println(ce);
	end = System.currentTimeMillis();
	System.out.println("Time waits = " + (end - start));
}


				System.out.println("----------------------------------");
				
				count ++;
				/* reads next line */
				line_form = file_forms.readLine();
				line_result = file_results.readLine();
			}
			
			System.out.println("\n\nNumber of fails = " + fails + " ( " + test_fails + ")");
			System.out.println("max time proof = " + max_time + " for formula " + max_time_form);
			
		}
		catch (IOException ioe)
		{
			System.out.println("test: No such file");
			System.out.println(ioe);
			stopCard();
			System.exit(2);
		}
		
		catch(Exception e)
		{
			System.out.println(">>>> EXCEPTION <<<<");
			System.out.println(e);
			stopCard();
	end = System.currentTimeMillis();
	System.out.println("Time waits = " + (end - start));
			System.exit(2);
		}
		
		stopCard();		
	}




	public static void testPC01(String dir)
	{
		LineNumberReader file_forms, file_results;
		String line_form, line_result;
		parser parser = new parser();
		proverInterface prover = new prover();
		
		converter converter = new converter();
		
		int output = 0;
		int count = 1;
		int fails = 0;
		String test_fails = "";
		long start = 0, end = 0;
		String filename_forms = "s4_formulae";
		String filename_results = "s4_results";
		
		if(dir != null)
		{
			filename_forms = dir + "\\" + filename_forms;
			filename_results = dir + "\\" + filename_results;
		}
		
		System.out.println("Read formulae from \"" + filename_forms + "\"");
		System.out.println("Read results from \"" + filename_results + "\"");
		try
		{
			file_forms = new LineNumberReader(new FileReader(filename_forms));
			file_results = new LineNumberReader(new FileReader(filename_results));
			
			line_form = file_forms.readLine();
			line_result = file_results.readLine();
			while(line_form != null)
			{
				if(line_form.equals(""))
				{
					System.out.println(">>>See an empty line in formulae files. Output may not match from here");
					line_form = file_forms.readLine();
					line_result = file_results.readLine();
					continue	;
				}
				System.out.println("\ninput to prover="+"\""+line_form+"\"");

				/* give the string to the scanner */
				scanner.getInput(line_form);

				try
				{
					parser.parse();
				} catch (Exception e)
				{
					System.out.println("--------Error in parser-------");
					stopCard();
					System.exit(2);
				}

				converter.convert(parser);

				System.out.println("\nStart sending 'childs' to the card");
				start = System.currentTimeMillis();
				
				
				int num_packs = (int)(converter.childs.length/PACKETLEN);
				short offset = 0;
				byte pack[];
				int pack_count = 0;
				for(int i=0; i<num_packs; i++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int j=0; j<PACKETLEN; j++)
						pack[j] = converter.childs[j+offset];

					prover.getChilds(pack, offset, PACKETLEN);
					offset += PACKETLEN;

					System.out.println("package " + pack_count);
				}
				
				/* last package */
				if(offset < converter.childs.length)
				{
					pack_count ++;
					byte len = (byte)(converter.childs.length - offset);
					pack = new byte[len];
					for(int j=0; j<len; j++)
						pack[j] = converter.childs[j+offset];
					
					prover.getChilds(pack, offset, len);
					
					System.out.println("package " + pack_count + " tota len = " + (offset + len));
				}
				

				System.out.println("\nStart sending 'nature' to the card");
				pack_count = 0;
				offset = 0;
				num_packs = (int)(converter.nature.length/PACKETLEN);
				
				for(int i=0; i<num_packs; i++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int j=0; j<PACKETLEN; j++)
						pack[j] = converter.nature[j+offset];
					
					prover.getNature(pack, (byte)offset, PACKETLEN);
					offset += PACKETLEN;
					
					System.out.println("package " + pack_count);
				}
				
				/* last package */
				if(offset < converter.nature.length)
				{
					pack_count ++;
					byte len = (byte)(converter.nature.length - offset);
					pack = new byte[len];
					for(int j=0; j<len; j++)
						pack[j] = converter.nature[j+offset];
					
					prover.getNature(pack, (byte)offset, len);
					
					System.out.println("package " + pack_count + " total len = " + (offset + len));
				}


				System.out.println("\nStart request for optimization");
				
				output = prover.simplify();
				
				System.out.println("Result = " + output);

				System.out.println("\nStart request for proof from the card");

				output = prover.prove();

				end = System.currentTimeMillis();
				

				if(output == 1) System.out.println("\noutput: SATISFIABLE");
				else System.out.println("\noutput: NOT SATISFIABLE");

				System.out.print("result: is satisfiable = " + line_result);
				if(output == 1)
				{
					if(line_result.equals("true")) System.out.println("\t\t\ttest " + count + " PASS");
					else
					{
						System.out.println("\t\t\ttest " + count + " FAIL");
						fails ++;
						test_fails += ("" + count + " ");
					}
				}
				else
				{
					if(line_result.equals("false")) System.out.println("\t\t\ttest " + count + " PASS");
					else
					{
						System.out.println("\t\t\ttest " + count + " FAIL");
						fails ++;
						test_fails += ("" + count + " ");
					}
				}
				
				
				System.out.println("Time total = " + (end - start));
				System.out.println("----------------------------------");
				
				count ++;
				/* reads next line */
				line_form = file_forms.readLine();
				line_result = file_results.readLine();
			}
			
			System.out.println("\n\nNumber of fails = " + fails + " ( " + test_fails + ")");
			
		}
		catch (IOException ioe)
		{
			System.out.println("test: No such file");
		}
	}




	
	public static void testProver(String dir)
	{
		LineNumberReader file_forms, file_results;
		String line_form;
		parser parser = new parser();
		proverInterface prover = new prover();
		
		converter converter = new converter();
		int output = 0;

		String filename_forms = "s4_formulae";
		int count = 1;
		
		if(dir != null)
		{
			filename_forms = dir + "\\" + filename_forms;
		}
		
		System.out.println("Read formulae from \"" + filename_forms + "\"");
		
		try
		{
			file_forms = new LineNumberReader(new FileReader(filename_forms));
			
			line_form = file_forms.readLine();
			while(line_form != null)
			{					
				System.out.println("\ninput to prover="+"\""+line_form+"\" (line " + count + ")");

				/* give the string to the scanner */
				scanner.getInput(line_form);


				try
				{
					parser.parse();
				} catch (Exception e)
				{
					System.out.println("--------Error in parser-------");
				}

				converter.convert(parser);

				System.out.println("\nStart sending 'childs' to the card");
				int num_packs = (int)(converter.childs.length/PACKETLEN);
				short offset = 0;
				byte pack[];
				int pack_count = 0;
				for(int i=0; i<num_packs; i++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int j=0; j<PACKETLEN; j++)
						pack[j] = converter.childs[j+offset];
					
					prover.getChilds(pack, offset, PACKETLEN);
					offset += PACKETLEN;
					
					System.out.println("package " + pack_count);
				}
				
				/* last package */
				if(offset < converter.childs.length)
				{
					pack_count ++;
					byte len = (byte)(converter.childs.length - offset);
					pack = new byte[len];
					for(int j=0; j<len; j++)
						pack[j] = converter.childs[j+offset];
					
					prover.getChilds(pack, offset, len);
					
					System.out.println("package " + pack_count);
				}
				

				System.out.println("\nStart sending 'nature' to the card");
				pack_count = 0;
				offset = 0;
				num_packs = (int)(converter.nature.length/PACKETLEN);
				
				for(int i=0; i<num_packs; i++)
				{
					pack_count ++;
					pack = new byte[PACKETLEN];
					for(int j=0; j<PACKETLEN; j++)
						pack[j] = converter.nature[j+offset];
					
					prover.getNature(pack, (byte)offset, PACKETLEN);
					offset += PACKETLEN;
					
					System.out.println("package " + pack_count);
				}
				
				/* last package */
				if(offset < converter.nature.length)
				{
					pack_count ++;
					byte len = (byte)(converter.nature.length - offset);
					pack = new byte[len];
					for(int j=0; j<len; j++)
						pack[j] = converter.nature[j+offset];
					
					prover.getNature(pack, (byte)offset, len);
					
					System.out.println("package " + pack_count);
				}


				System.out.println("\nStart request for optimization");
				
				output = prover.simplify();
				
				System.out.println("Result = " + output);

				System.out.println("\nStart request for proof from the card");
				
				output = prover.prove();


				if(output == 1) System.out.println("\noutput: SATISFIABLE");
				else System.out.println("\noutput: NOT SATISFIABLE");

				System.out.println("----------------------------------");
				
				count ++;
				/* reads next line */
				line_form = file_forms.readLine();
			}
			
		}
		catch (IOException ioe)
		{
			System.out.println("testProver: No such file");
		}		
	}
	
	public static void testParser(String dir)
	{
		LineNumberReader file;
		String line;
		parser parser = new parser();
		String filename_forms = "s4_formulae";
		int count = 1;
		
		if(dir != null)
		{
			filename_forms = dir + "\\" + filename_forms;
		}
		
		System.out.println("Read formulae from \"" + filename_forms + "\"");


		try
		{
			file = new LineNumberReader(new FileReader(filename_forms));
			
			line = file.readLine();
			while(line != null)
			{
				if(line.equals(""))
				{
				line = file.readLine();
					continue;
				}
								
				System.out.println("\ninput to parser="+"\""+line+"\"" + " (line " + count + ")");
				count ++;
				
				/* give the string to the scanner */
				scanner.getInput(line);

				try
				{
					parser.parse();
					parser.action_obj.display();
					System.out.println("----------------------------------");
				} catch (Exception e)
				{
					System.out.println("--------Error in parser-------");
				}

				/* reads next line */
				line = file.readLine();
			}
			
		}
		catch (IOException ioe)
		{
			System.out.println("test: No such file");
		}		
	}

	public static void testConverter(String dir)
	{
		LineNumberReader file;
		String line;
		parser parser = new parser();
		converter converter = new converter();
		String filename_forms = "s4_formulae";
		int count = 1;
		
		if(dir != null)
		{
			filename_forms = dir + "\\" + filename_forms;
		}
		
		System.out.println("Read formulae from \"" + filename_forms + "\"");


		try
		{
			file = new LineNumberReader(new FileReader(filename_forms));
			
			line = file.readLine();
			while(line != null)
			{
				if(line.equals(""))
				{
				line = file.readLine();
					continue;
				}
								
				System.out.println("\ninput to parser="+"\""+line+"\"" + " (line " + count + ")");
				count ++;
				
				/* give the string to the scanner */
				scanner.getInput(line);

				try
				{
					parser.parse();
					parser.action_obj.display();
					System.out.println("----------------------------------");
				} catch (Exception e)
				{
					System.out.println("--------Error in parser-------");
				}


				System.out.println("\n\n>>>>>>>>>>>>>> CONVERT <<<<<<<<<<<<<<<<<<<<<<\n");
				converter.convert(parser);
				converter.display();
				
				/* reads next line */
				line = file.readLine();
			}
			
		}
		catch (IOException ioe)
		{
			System.out.println("test: No such file");
		}		
	}

}			