/*
 *******************************************************************
 *
 * FILE
 *
 * proverInterface.java
 * by Phuong, The NGUYEN
 *
 * an interface for the prover residing on the card
 * as part of a summer scholarship in RSISE - ANU
 * supervised by: Rajeev, Prabhakar GORE
 *
 * begin: 27 Jan 01
 * last updated: 5 Feb 01
 *
 *******************************************************************
 */


/* to reside in a card, it must belong to a package and implement a 
 * common interface so that the PC (client) can communicate with it 
 */
package card;

public interface proverInterface
{
	/* Constants declarations */

    public static final int MAXFORMLEN = 256;

	public static final int RAMSIZE = 512;
    public static final byte MASK = 7;
    public static final byte TRUE = 0;
    public static final byte FALSE = 1;
    public static final byte ATOM_START = 1;
    
    /* constants used to indicate the nature of a node in the parse tree */
    public static final byte PROP = 1;
    public static final byte NEGA = 2;
    public static final byte CONJ = 3;
    public static final byte DISJ = 4;
    public static final byte ALL  = 5;
    public static final byte SOME = 6;

	/* step to increment the stack */
	public static final byte STEP = 10;
	
	/* methods implemented by the prover */
	public byte prove();
	public byte simplify();
	public void getChilds(byte [] c, short start, byte len);
	public void getNature(byte [] n, byte start, byte len);
}