//package client;


/*
 *******************************************************************
 *
 * FILE
 *
 * scanner.java
 * by Phuong, The NGUYEN
 *
 * a scanner to scan formulae in the logics S4
 * as part of a summer scholarship in RSISE - ANU
 * supervised by: Rajeev, Prabhakar GORE
 *
 * begin: 26 Jan 01
 * last updated: 21 Feb 01
 *
 *******************************************************************
 *
 * ACKNOWLEDGEMENT
 *
 * This is a modification of lexerKt.cup by Lan, Duy NGUYEN
 *
 *******************************************************************
 *
 * HOW IT WORKS
 *
 * currently it does not have the imply yet
 *
 * Note:
 * AND: &, OR: |, ALL: [], SOME: <>, NEGA: ~
 * True is 1, there is no false (must be supplied as ~1)
 * Propositions must start with capital letters. This is for later
 * (if any) use of muti-modal logics: one can name a modal with
 * something that start with lower case letter.
 *
 * space, tabs are ignored. New line is to terminate
 *
 *******************************************************************
 */

package client;
import java_cup.runtime.*;

public class scanner {

	/* current position in the string */
	protected static int cur_pos = 0;

  	/* the string to be parsed. Converted to int, for *switch* */
  	public static int input [] = null;
  	
  	/* the buffer to hold the current propositional atom */
  	public static byte buf[] = null;


	/* the scanner will be presented with a formula (string) */
	public static void getInput(String formula)
	{
  		input = new int[formula.length() + 1];
  		int i = 0;
  		for(i=0; i<formula.length(); i++)
  		{
  			input[i] = (int) formula.charAt(i);
  		}
  		input[input.length - 1] = -1;
  	}

	
	/* initialization of the scanner */
  	public static void init()
  	{
  		cur_pos = 0;
  		buf = new byte[input.length]; /* max. length of an atom */


  	}
  
    public static Symbol next_token() throws java.io.IOException
    {
      	for (;;)
      	{
        	switch (input[cur_pos])
          	{
          		/* atomic formulae */
	    		case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
	    		case 'G': case 'H': case 'I': case 'J': case 'K': case 'L': 
	    		case 'M': case 'N': case 'O': case 'P': case 'Q': case 'R': 
	    		case 'S': case 'T': case 'U': case 'V': case 'W': case 'X': 
	    		case 'Y': case 'Z':
	    		
	    			int i=0;
	    			do
	    			{
	    				buf[i++] = (byte) (input[cur_pos++]);
	    			} while (	(input[cur_pos] >= 'A' && input[cur_pos] <= 'Z') ||
	    						(input[cur_pos] >= 'a' && input[cur_pos] <= 'z') ||
	    						(input[cur_pos] >= '0' && input[cur_pos] <= '9'));
	    						
	    			return new Symbol(sym.ATOM, new String(buf,0,i));

				/* square brackets for all, angle for some */
		    	case '[': cur_pos++; return new Symbol(sym.LSQU);
		    	case ']': cur_pos++; return new Symbol(sym.RSQU);
	    		case '<': cur_pos++; return new Symbol(sym.LANG);
		    	case '>': cur_pos++; return new Symbol(sym.RANG);
		    	
		    	/* logical connectives: should have for imply as well */
		    	case '~': cur_pos++; return new Symbol(sym.NOT);
	    		case '&': cur_pos++; return new Symbol(sym.AND);
			    case '|': cur_pos++; return new Symbol(sym.OR);
			    
			    /* constant: TRUE and FALSE */
        	    case '1': cur_pos++; return new Symbol(sym.ATOM, "1");
            	
            	/* grouping */
	    		case '(': cur_pos++; return new Symbol(sym.LPAR);
	    		case ')': cur_pos++; return new Symbol(sym.RPAR);
	    		
	    		/* end of string */
		    	case -1: return new Symbol(sym.EOF);
		    	
		    	/* ignore white space (outside of atom, of course) */
		    	case ' ': case '\t': cur_pos ++; break;
		    	
		    	/* we should report error here */
            	default: cur_pos ++;
            		break;
          	}
    	}
    }
}